// PPgFiles.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgFiles.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgFiles dialog

IMPLEMENT_DYNAMIC(CPPgFiles, CPropertyPage)
CPPgFiles::CPPgFiles()
	: CPropertyPage(CPPgFiles::IDD)
{
}

CPPgFiles::~CPPgFiles()
{
}

void CPPgFiles::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgFiles, CPropertyPage)
	ON_BN_CLICKED(IDC_SEESHARE1, OnSettingsChange)
	ON_BN_CLICKED(IDC_SEESHARE2, OnSettingsChange)
	ON_BN_CLICKED(IDC_SEESHARE3, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_LOWER, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_IDLE, OnSettingsChange)
	ON_EN_CHANGE(IDC_AP_HIGH, OnSettingsChange) // DonGato
	ON_EN_CHANGE(IDC_AP_LOW, OnSettingsChange) // DonGato
	ON_BN_CLICKED(IDC_UAP, OnSettingsChange)	// Tarod
	ON_BN_CLICKED(IDC_DAP_ENABLE, OnBnClickedDAP) // DonGato
	ON_BN_CLICKED(IDC_START_PAUSED, OnSettingsChange) // Tarod
	ON_BN_CLICKED(IDC_START_PAUSED_ON_COMPLETE, OnSettingsChange) // Tarod
	ON_BN_CLICKED(IDC_REMOVENNS, OnSettingsChange) // Tarod
	ON_EN_CHANGE(IDC_MAXSOURCEPERFILE, OnSettingsChange)
	ON_EN_KILLFOCUS(IDC_MAXSOURCEPERFILE, OnSourcesChange)
	ON_BN_CLICKED(IDC_SLOWCOMPLETE, OnBnClickedSlowComplete)
	ON_EN_CHANGE(IDC_SLOWCOMPLETE_BLOCK, OnSettingsChange) // DonGato
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

BOOL CPPgFiles::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgFiles::LoadSettings(void)
{	
	switch(app_prefs->CanSeeShares())
	{
		case SEE_SHARE_EVERYBODY:
			CheckDlgButton(IDC_SEESHARE1,1);
			break;
		case SEE_SHARE_FRIENDS:
			CheckDlgButton(IDC_SEESHARE2,1);
			break;
		case SEE_SHARE_NOONE:
		default:
			CheckDlgButton(IDC_SEESHARE3,1);
			break;
	}

	// DonGato
	switch(app_prefs->GetHashingPriority())
	{
		case 0:
			CheckDlgButton(IDC_HASHPRIO_IDLE,1);
			break;
		case 1:
			CheckDlgButton(IDC_HASHPRIO_LOWER,1);
			break;
		default:
			CheckDlgButton(IDC_HASHPRIO_STANDARD,1);
			break;
	}

	// Tarod
	if(app_prefs->IsUAPEnabled())
		CheckDlgButton(IDC_UAP,1);
	else
		CheckDlgButton(IDC_UAP,0);

	// DonGato
	if(app_prefs->IsDAPEnabled())
		CheckDlgButton(IDC_DAP_ENABLE,1);
	else
		CheckDlgButton(IDC_DAP_ENABLE,0);
	OnBnClickedDAP();

	CString strBuffer;
	strBuffer.Format("%d", app_prefs->PriorityHigh());
	GetDlgItem(IDC_AP_HIGH)->SetWindowText(strBuffer);
	strBuffer.Format("%d", app_prefs->PriorityLow());
	GetDlgItem(IDC_AP_LOW)->SetWindowText(strBuffer);

	if(app_prefs->GetMaxSourcePerFile() == 0xFFFF)
		GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText("99999");
	else
	{
		strBuffer.Format("%d", app_prefs->GetMaxSourcePerFile());
		GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText(strBuffer);
	}

	// Tarod
	if (app_prefs->StartDownloadPaused())
		CheckDlgButton(IDC_START_PAUSED, 1);
	else
		CheckDlgButton(IDC_START_PAUSED, 0);
	if (app_prefs->DownloadPausedOnComplete())
		CheckDlgButton(IDC_START_PAUSED_ON_COMPLETE, 1);
	else
		CheckDlgButton(IDC_START_PAUSED_ON_COMPLETE, 0);
	if (app_prefs->IsRemoveNNSEnabled())
		CheckDlgButton(IDC_REMOVENNS, 1);
	else
		CheckDlgButton(IDC_REMOVENNS, 0);

	if (app_prefs->SlowComplete())
		CheckDlgButton(IDC_SLOWCOMPLETE, 1);
	else
		CheckDlgButton(IDC_SLOWCOMPLETE, 0);
	OnBnClickedSlowComplete();

	// Barry
	((CSliderCtrl*)GetDlgItem(IDC_FILEBUFFERSIZE))->SetRange(1,100,true);
	((CSliderCtrl*)GetDlgItem(IDC_FILEBUFFERSIZE))->SetPos(app_prefs->GetFileBufferSize());
	m_iFileBufferSize = app_prefs->GetFileBufferSize();

	strBuffer.Format("%d", app_prefs->SlowCompleteBlockSize());
	GetDlgItem(IDC_SLOWCOMPLETE_BLOCK)->SetWindowText(strBuffer);
	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgFiles::OnApply()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		if(IsDlgButtonChecked(IDC_SEESHARE1))
			app_prefs->SetCanSeeShares(SEE_SHARE_EVERYBODY);
		else if(IsDlgButtonChecked(IDC_SEESHARE2))
			app_prefs->SetCanSeeShares(SEE_SHARE_FRIENDS);
		else
			app_prefs->SetCanSeeShares(SEE_SHARE_NOONE);

		// DonGato
		if(IsDlgButtonChecked(IDC_HASHPRIO_IDLE))
		{
			app_prefs->SetHashingPriority(HASH_PRIORITY_IDLE);
			theApp.m_FilesHashing.SetProcessingPriority(ePIdle);
		}
		else if(IsDlgButtonChecked(IDC_HASHPRIO_LOWER))
		{
			app_prefs->SetHashingPriority(HASH_PRIORITY_LOWER);
			theApp.m_FilesHashing.SetProcessingPriority(ePLower);
		}
		else
		{
			app_prefs->SetHashingPriority(HASH_PRIORITY_STANDARD);
			theApp.m_FilesHashing.SetProcessingPriority(ePStandard);
		}
		char buffer[100];
		if(GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowTextLength())
		{
			GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowText(buffer,20);
			app_prefs->SetMaxSourcePerFile( (atoi(buffer)) ? atoi(buffer) : 10);
		}

		// Added by Tarod
		app_prefs->SetUAPEnabled( (int8)IsDlgButtonChecked(IDC_UAP));
		app_prefs->SetDAPEnabled( (int8)IsDlgButtonChecked(IDC_DAP_ENABLE));
		app_prefs->SetStartDownloadPaused((int8)IsDlgButtonChecked(IDC_START_PAUSED)) ;
		app_prefs->SetDownloadPausedOnComplete( (int8)IsDlgButtonChecked(IDC_START_PAUSED_ON_COMPLETE)) ;
		app_prefs->SetRemoveNNSEnabled( (int8)IsDlgButtonChecked(IDC_REMOVENNS));

		// DonGato
		
		GetDlgItem(IDC_AP_HIGH)->GetWindowText(buffer,7);
		app_prefs->SetPriorityHigh(atoi(buffer));
		GetDlgItem(IDC_AP_LOW)->GetWindowText(buffer,7);
		app_prefs->SetPriorityLow(atoi(buffer));
		if(app_prefs->PriorityLow() < app_prefs->PriorityHigh())
		{
			app_prefs->SetPriorityLow( app_prefs->PriorityHigh()*2);
			sprintf(buffer, "%d",app_prefs->PriorityLow());
			GetDlgItem(IDC_AP_LOW)->SetWindowText(buffer);
		}
		
		// Barry
		app_prefs->SetFileBufferSize(m_iFileBufferSize);

		app_prefs->SetSlowComplete((int8)IsDlgButtonChecked(IDC_SLOWCOMPLETE));
		GetDlgItem(IDC_SLOWCOMPLETE_BLOCK)->GetWindowText(buffer, 20);
		app_prefs->SetSlowCompleteBlockSize(atoi(buffer));
		if (app_prefs->SlowCompleteBlockSize() > 1024)
		{
			app_prefs->SetSlowCompleteBlockSize(1024);
			sprintf(buffer, "%d",app_prefs->SlowCompleteBlockSize());
			GetDlgItem(IDC_SLOWCOMPLETE_BLOCK)->SetWindowText(buffer);
		} 

		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgFiles::Localize(void)
{
	if(GetSafeHwnd())
	{
		SetWindowText(GetResString(IDS_PW_FILES));
		GetDlgItem(IDC_SEEMYSHARE_FRM)->SetWindowText(GetResString(IDS_PW_SHARE));
		GetDlgItem(IDC_SEESHARE1)->SetWindowText(GetResString(IDS_PW_EVER));
		GetDlgItem(IDC_SEESHARE2)->SetWindowText(GetResString(IDS_PW_FRIENDS));
		GetDlgItem(IDC_SEESHARE3)->SetWindowText(GetResString(IDS_PW_NOONE));
		GetDlgItem(IDC_AP_GRP)->SetWindowText(GetResString(IDS_AP_GRP));
		GetDlgItem(IDC_AP_HIGH_LBL)->SetWindowText(GetResString(IDS_AP_HIGH_LBL));
		GetDlgItem(IDC_AP_LOW_LBL)->SetWindowText(GetResString(IDS_AP_LOW_LBL));
		GetDlgItem(IDC_DAP_ENABLE)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_UAP)->SetWindowText(GetResString(IDS_UAP));
		GetDlgItem(IDC_START_PAUSED)->SetWindowText(GetResString(IDS_START_PAUSED));
		GetDlgItem(IDC_START_PAUSED_ON_COMPLETE)->SetWindowText(GetResString(IDS_START_PAUSED_ON_COMPLETE));
		GetDlgItem(IDC_REMOVENNS)->SetWindowText(GetResString(IDS_REMOVENNS));
		GetDlgItem(IDC_AP_SOURCES1)->SetWindowText(GetResString(IDS_SOURCES_PF_FILES));
		GetDlgItem(IDC_AP_SOURCES2)->SetWindowText(GetResString(IDS_SOURCES_PF_FILES));
		GetDlgItem(IDC_SLOWCOMPLETE)->SetWindowText(GetResString(IDS_SLOWCOMPLETE));
		GetDlgItem(IDC_SLOWCOMPLETE_KB)->SetWindowText(GetResString(IDS_KBYTES));
		GetDlgItem(IDC_HASHING_FRM)->SetWindowText(GetResString(IDS_HASHING_FRM));
		GetDlgItem(IDC_MAXSRC_LBL)->SetWindowText(GetResString(IDS_PW_MAXSOURCES));
		GetDlgItem(IDC_HASHPRIO_STANDARD)->SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		GetDlgItem(IDC_HASHPRIO_LOWER)->SetWindowText(GetResString(IDS_HASHPRIO_LOWER));
		GetDlgItem(IDC_HASHPRIO_IDLE)->SetWindowText(GetResString(IDS_HASHPRIO_IDLE));
		CString temp;
		temp.Format(GetResString(IDS_FILEBUFFERSIZE), m_iFileBufferSize*15000);
		GetDlgItem(IDC_FILEBUFFERSIZE_LBL)->SetWindowText(temp);
	}
}

void CPPgFiles::OnSourcesChange()
{
	char buffer[30];
	CString sBuffer;
	uint16 num=0;
	if(GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowText(buffer,20);
		num=((atoi(buffer)) ? atoi(buffer) : 10);	
	}
	num=(num<10)?10:num;
	if (num != app_prefs->GetMaxSourcePerFile())
	{
		sBuffer.Format("%u",num);
		GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText(sBuffer);
	}
}

void CPPgFiles::OnBnClickedDAP()
{
	GetDlgItem(IDC_AP_HIGH)->EnableWindow(IsDlgButtonChecked(IDC_DAP_ENABLE));	
	GetDlgItem(IDC_AP_LOW)->EnableWindow(IsDlgButtonChecked(IDC_DAP_ENABLE));	

	SetModified();
}

void CPPgFiles::OnBnClickedSlowComplete()
{
	GetDlgItem(IDC_SLOWCOMPLETE_BLOCK)->EnableWindow(IsDlgButtonChecked(IDC_SLOWCOMPLETE));

	SetModified();
}

void CPPgFiles::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	CString temp;
	if (pScrollBar==GetDlgItem(IDC_FILEBUFFERSIZE))
	{
		m_iFileBufferSize = slider->GetPos();
		temp.Format( GetResString(IDS_FILEBUFFERSIZE), m_iFileBufferSize*15000 );
		GetDlgItem(IDC_FILEBUFFERSIZE_LBL)->SetWindowText(temp);
	}
}
