// PPgServer.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgServer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgServer dialog

IMPLEMENT_DYNAMIC(CPPgServer, CPropertyPage)
CPPgServer::CPPgServer()
	: CPropertyPage(CPPgServer::IDD)
{
}

CPPgServer::~CPPgServer()
{
}

void CPPgServer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CPPgServer, CPropertyPage)
	ON_EN_CHANGE(IDC_SRVCONTIMEOUT, OnEnChangeSrvConTimeout)
	ON_EN_CHANGE(IDC_SERVERRETRIES, OnEnChangeServerretries)
	ON_BN_CLICKED(IDC_AUTOSERVER, OnBnClickedAutoserver)
	ON_BN_CLICKED(IDC_UPDATESERVERCONNECT, OnBnClickedUpdateserverconnect)
	ON_BN_CLICKED(IDC_FILTER, OnBnClickedFilter)
	ON_BN_CLICKED(IDC_SCORE, OnBnClickedScore)
	ON_BN_CLICKED(IDC_REMOVEDEAD, OnBnClickedRemovedead)
	ON_BN_CLICKED(IDC_RESTARTWAITING, OnBnClickedRestartWaiting)
	ON_BN_CLICKED(IDC_SAFECONNECT, OnBnClickedFastConnect)
	ON_BN_CLICKED(IDC_SMARTIDCHECK, OnBnClickedSmartIdCheck)
	ON_BN_CLICKED(IDC_AUTOCONNECT, OnBnClickedAutoconnect)
	ON_BN_CLICKED(IDC_RECONN, OnBnClickedReconn)
	ON_BN_CLICKED(IDC_AUTOCONNECTSTATICONLY, OnBnClickedStaticOnly)
END_MESSAGE_MAP()


// CPPgServer message handlers

void CPPgServer::OnBnClickedCheck1()
{
	// TODO: Add your control notification handler code here
}

BOOL CPPgServer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgServer::LoadSettings(void)
{
	CString strBuffer;

	strBuffer.Format("%d", app_prefs->SrvConTimeout()/1000);		//Cax2 - bugfix for time out - ticks are in milliseconds!!!!!
	GetDlgItem(IDC_SRVCONTIMEOUT)->SetWindowText(strBuffer);

	strBuffer.Format("%d", app_prefs->GetDeadserverRetries());
	GetDlgItem(IDC_SERVERRETRIES)->SetWindowText(strBuffer);
		
	if(app_prefs->IsSafeConnectEnabled())
		CheckDlgButton(IDC_SAFECONNECT,1);
	else
		CheckDlgButton(IDC_SAFECONNECT,0);

	if(app_prefs->GetSmartIdCheck())
		CheckDlgButton(IDC_SMARTIDCHECK,1);
	else
		CheckDlgButton(IDC_SMARTIDCHECK,0);

	if(app_prefs->DeadServer())
		CheckDlgButton(IDC_REMOVEDEAD,1);
	else
		CheckDlgButton(IDC_REMOVEDEAD,0);
	OnBnClickedRemovedead();
	
	if(app_prefs->AutoServerlist())
		CheckDlgButton(IDC_AUTOSERVER,1);
	else
		CheckDlgButton(IDC_AUTOSERVER,0);

	if(app_prefs->GetAddServersFromConn())
		CheckDlgButton(IDC_UPDATESERVERCONNECT, 1);
	else
		CheckDlgButton(IDC_UPDATESERVERCONNECT, 0);

	if(app_prefs->FilterBadIPs())
		CheckDlgButton(IDC_FILTER,1);
	else
		CheckDlgButton(IDC_FILTER,0);

	if(app_prefs->Score())
		CheckDlgButton(IDC_SCORE,1);
	else
		CheckDlgButton(IDC_SCORE,0);

	if(app_prefs->RestartWaiting())
		CheckDlgButton(IDC_RESTARTWAITING,1);
	else
		CheckDlgButton(IDC_RESTARTWAITING,0);

	if (app_prefs->Reconnect())
		CheckDlgButton(IDC_RECONN,1);
	else
		CheckDlgButton(IDC_RECONN,0);

	if (app_prefs->DoAutoConnect())
		CheckDlgButton(IDC_AUTOCONNECT,1);
	else
		CheckDlgButton(IDC_AUTOCONNECT,0);

	// Barry
	if(app_prefs->AutoConnectStaticOnly())
		CheckDlgButton(IDC_AUTOCONNECTSTATICONLY,1);
	else
		CheckDlgButton(IDC_AUTOCONNECTSTATICONLY,0);

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgServer::OnApply()
{	
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		char buffer[510];
		
		app_prefs->SetDeadServer((int8)IsDlgButtonChecked(IDC_REMOVEDEAD));
		
		app_prefs->SetSafeConnectEnabled((int8)IsDlgButtonChecked(IDC_SAFECONNECT));
	
		if(IsDlgButtonChecked(IDC_SMARTIDCHECK))
			app_prefs->SetSmartIdCheck(true);
		else
			app_prefs->SetSmartIdCheck(false);
	
		GetDlgItem(IDC_SRVCONTIMEOUT)->GetWindowText(buffer,7);
		app_prefs->SetSrvConTimeout(atoi(buffer)*1000);		//Cax2 - bugfix for time out - ticks are in milliseconds!!!!!
		if(app_prefs->SrvConTimeout() < 10000)
			app_prefs->SetSrvConTimeout(10000);
		else if(app_prefs->SrvConTimeout() > 60000)
			app_prefs->SetSrvConTimeout(60000);

		sprintf(buffer, "%d",app_prefs->SrvConTimeout()/1000);
		GetDlgItem(IDC_SRVCONTIMEOUT)->SetWindowText(buffer);

		if(GetDlgItem(IDC_SERVERRETRIES)->GetWindowTextLength())
		{
			GetDlgItem(IDC_SERVERRETRIES)->GetWindowText(buffer,20);
			app_prefs->SetDeadserverRetries( (atoi(buffer)) ? atoi(buffer) : 5);
		}
		if(app_prefs->GetDeadserverRetries() < 1) 
			app_prefs->SetDeadserverRetries(5);
	
		app_prefs->SetScore((int8)IsDlgButtonChecked(IDC_SCORE));
		app_prefs->SetAutoServerlist((int8)IsDlgButtonChecked(IDC_AUTOSERVER));
		app_prefs->SetAddServersFromConn((int8)IsDlgButtonChecked(IDC_UPDATESERVERCONNECT));
		app_prefs->SetFilterBadIPs((int8)IsDlgButtonChecked(IDC_FILTER));
		app_prefs->SetRestartWaiting((int8)IsDlgButtonChecked(IDC_RESTARTWAITING));
	
		app_prefs->SetAutoConnect((int8)IsDlgButtonChecked(IDC_AUTOCONNECT));
		app_prefs->SetReconnect((int8)IsDlgButtonChecked(IDC_RECONN));

		// Barry
		app_prefs->SetAutoConnectStaticOnly((int8)IsDlgButtonChecked(IDC_AUTOCONNECTSTATICONLY));

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgServer::Localize(void)
{
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_SERVER));
		
		GetDlgItem(IDC_SRVCONTIMEOUT_LBL)->SetWindowText(GetResString(IDS_SRVCONTIMEOUT_LBL));
		GetDlgItem(IDC_SRV_SEC)->SetWindowText(GetResString(IDS_SECS));

		GetDlgItem(IDC_REMOVEDEAD)->SetWindowText(GetResString(IDS_PW_RDEAD));
		GetDlgItem(IDC_RETRIES_LBL)->SetWindowText(GetResString(IDS_PW_RETRIES));
		
		GetDlgItem(IDC_UPDATESERVERCONNECT)->SetWindowText(GetResString(IDS_PW_USC));
		//GetDlgItem(IDC_UPDATESERVERCLIENT)->SetWindowText(GetResString(IDS_PW_UCC));		//merged into one...
		GetDlgItem(IDC_FILTER)->SetWindowText(GetResString(IDS_PW_FILTER));
		GetDlgItem(IDC_AUTOSERVER)->SetWindowText(GetResString(IDS_PW_USS));
		
		GetDlgItem(IDC_SCORE)->SetWindowText(GetResString(IDS_PW_SCORE));		
		GetDlgItem(IDC_RESTARTWAITING)->SetWindowText(GetResString(IDS_RESTARTWAITING));	
		GetDlgItem(IDC_SMARTIDCHECK)->SetWindowText(GetResString(IDS_SMARTLOWIDCHECK));
		GetDlgItem(IDC_SAFECONNECT)->SetWindowText(GetResString(IDS_PW_FASTSRVCON));

		GetDlgItem(IDC_AUTOCONNECT)->SetWindowText(GetResString(IDS_PW_AUTOCON));
		GetDlgItem(IDC_RECONN)->SetWindowText(GetResString(IDS_PW_RECON));

		// Barry
		GetDlgItem(IDC_AUTOCONNECTSTATICONLY)->SetWindowText(GetResString(IDS_PW_AUTOCONNECTSTATICONLY));
	}
}

void CPPgServer::OnBnClickedRemovedead()
{
	GetDlgItem(IDC_SERVERRETRIES)->EnableWindow(IsDlgButtonChecked(IDC_REMOVEDEAD));

	SetModified();
}
