#pragma once

enum SecuredVarErrors
{
	VariableNotInitialized
};


// Secured variable and array
template <class T> class CSecuredVar
{
	friend T;
public:
	CSecuredVar()
	{
		m_bInitialized = false;
	}
	CSecuredVar(T NewVal)
	{
		Put(NewVal);
	}

	~CSecuredVar()
	{
	}

	T Get()
	{
		CSingleLock AccessLock(&m_Access, TRUE);
		if(!m_bInitialized)
			throw VariableNotInitialized;
		T TempVal = m_Val;
		return TempVal;
	}


	void Put(T NewVal)
	{
		CSingleLock AccessLock(&m_Access, TRUE);
		m_bInitialized = true;
		m_Val = NewVal;
	}
	void operator=(T NewVal)
	{
		Put(NewVal);
	}
	operator T()
	{
		return Get();
	}
	T& operator=(CSecuredVar<T> &NewVal)
	{
		Put(NewVal.Get());
		return *this;
	}
	operator CSecuredVar<T>&()
	{
		return *this;
	}

private:
	T m_Val;

	CMutex	m_Access;
	bool	m_bInitialized;
};

