// OpCode.cpp: implementation of the COpCode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#ifdef NEW_SOCKETS
#include "OpCode.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COpCode::COpCode()
{

}

COpCode::~COpCode()
{

}

void CStream::Write_T(const CString& strObj)
{
	USHORT nLen = (USHORT) strObj.GetLength();
	Write_T(nLen);
	Write((PCSTR) strObj, nLen);
}

void CStream::Read_T(CString& strObj)
{
	USHORT nLen = 0;
	Read_T(nLen);
	Read_Str(strObj, nLen);
}

void CStream::Read_Str(CString& strObj, USHORT nLen)
{
	if (nLen)
	{
		PSTR szBuf = strObj.GetBuffer(nLen + 1);
		ASSERT(szBuf); // rather throws an exception

		Read(szBuf, nLen);
		strObj.ReleaseBuffer(nLen);
	} 
}

void CStream::Write_T(const CTag& stTag)
{
	WriteTag(
		stTag.m_nTagID,
		stTag.m_nTagID ? NULL : &stTag.m_strTagName,
		stTag.m_dwValue,
		stTag.m_bIsString ? &stTag.m_strValue : NULL);
}

void CStream::Read_T(CTag& stTag)
{
	BYTE nType = 0;
	Read_T(nType);

	USHORT nTagIdLen = 0;
	Read_T(nTagIdLen);
	if (sizeof(stTag.m_nTagID) == nTagIdLen)
		Read_T(stTag.m_nTagID);
	else
		Read_Str(stTag.m_strTagName, nTagIdLen);

	if (stTag.m_bIsString = (2 == nType))
		Read_T(stTag.m_strValue);
	else
		Read_T(stTag.m_dwValue);
}

void CStream::WriteTag(BYTE nTagID, const CString* pTagName, DWORD dwValue, const CString* pValue)
{
	BYTE nType = pValue ? 2 : 3;
	Write_T(nType);

	if (pTagName)
		Write_T(*pTagName);
	else
	{
		USHORT nTagIdLen = sizeof(nTagID);
		Write_T(nTagIdLen);
		Write_T(nTagID);
	}

	if (pValue)
		Write_T(*pValue);
	else
		Write_T(dwValue);
}

void COpCode_HELLO_TYPE::Z_Write(CStream& stStream)
{
	BYTE nHashSize = sizeof(m_pHash);
	stStream.Write_T(nHashSize);
	stStream.Write_T(m_pHash);
	stStream.Write_T(m_dwClientID);
	stStream.Write_T(m_nPort);

	DWORD dwTagCount = 3;
	stStream.Write_T(dwTagCount);

	stStream.WriteTag(CT_NAME, NULL, 0, &m_strNick);
	stStream.WriteTag(CT_VERSION, NULL, m_dwVersion, NULL);
	stStream.WriteTag(CT_PORT, NULL, m_nPort, NULL);

	stStream.Write_T(m_dwServerIp);
	stStream.Write_T(m_nServerPort);
}

void COpCode_HELLO_TYPE::Z_Read(CStream& stStream)
{
	BYTE nHashSize = 0;
	stStream.Read_T(nHashSize);
	if (sizeof(m_pHash) != nHashSize)
		CStream::CException::Throw();

	stStream.Read_T(m_pHash);
	stStream.Read_T(m_dwClientID);
	stStream.Read_T(m_nPort);

	DWORD dwTagCount = 0;
	stStream.Read_T(dwTagCount);

	while (dwTagCount--)
	{
		CTag stTag;
		stStream.Read_T(stTag);

		switch (stTag.m_nTagID)
		{
		case CT_NAME:
			if (stTag.m_bIsString)
				m_strNick = stTag.m_strValue;
			break;
		case CT_VERSION:
			if (!stTag.m_bIsString)
				m_dwVersion = stTag.m_dwValue;
			break;
		case CT_PORT:
//			if (!stTag.m_bIsString)
//				m_nPort = (USHORT) stTag.m_dwValue;
			break;
		}
	}

	stStream.Read_T(m_dwServerIp);
	stStream.Read_T(m_nServerPort);
}

#endif