//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// TransferWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "TransferWnd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CTransferWnd dialog

IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)
CTransferWnd::CTransferWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CTransferWnd::IDD, pParent)
{
}

CTransferWnd::~CTransferWnd()
{
	SafeRollupItemHeights();
}

BEGIN_MESSAGE_MAP(CTransferWnd, CResizableDialog)
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT,0,0xFFFF,OnToolTipNotify)
END_MESSAGE_MAP()


BOOL CTransferWnd::OnInitDialog()
{
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	m_bFirstShow=true;
	Localize();

	CRect rRollupArea;
	GetClientRect(&rRollupArea);
	rRollupArea.DeflateRect(11,11); // (7,7)

	rollupctrl.Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, rRollupArea, this, 123);
	
	CRect rItem = rRollupArea;
	rItem.top += 22;
	rItem.bottom = rItem.top + (rRollupArea.Height() - 3 * 22) / 2;
	downloadlistctrl.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | 
							LVS_NOLABELWRAP | LVS_OWNERDRAWFIXED | LVS_SINGLESEL, rItem, &rollupctrl, IDC_DOWNLOADLIST);
	downloadlistctrl.Init();
	downloadlistctrl.SetOwner(this);
		
	rItem.top = rItem.bottom + 22;
	rItem.bottom = rItem.top + (rRollupArea.Height() - 3 * 22) / 4;
	uploadlistctrl.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | LVS_SINGLESEL | LVS_OWNERDRAWFIXED,
							rItem, &rollupctrl, IDC_UPLOADLIST);
	uploadlistctrl.Init();
	uploadlistctrl.SetOwner(this);

	queuelistctrl.Create(/*WS_VISIBLE |*/ WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | LVS_SINGLESEL | LVS_OWNERDRAWFIXED,
							rItem, &rollupctrl, IDC_QUEUELIST);
	queuelistctrl.Init();
	queuelistctrl.SetOwner(this);

    m_nActiveWnd = 0;

	rItem.top = rItem.bottom + 22;
	rItem.bottom = rItem.top + (rRollupArea.Height() - 3 * 22) / 4;
	infolistctrl.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | LVS_SINGLESEL,
							rItem, &rollupctrl, 127);

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_DOWNINFO), theApp.downloadqueue->GetFileCount(),
						theApp.downloadqueue->GetTransferingFiles(),
							(float)theApp.downloadqueue->GetDatarate() / 1024);
	rollupctrl.InsertItem(GetResString(IDS_RUP_DOWNLOADS), strBuffer, &downloadlistctrl, 0, TRUE);


	strBuffer.Format(GetResString(IDS_RUP_UPINFO), theApp.uploadqueue->GetWaitingUserCount(),
						theApp.uploadqueue->GetUploadQueueLength(), 
							theApp.uploadqueue->GetBanCount(),
								(float)theApp.uploadqueue->GetDatarate()/1024);
	rollupctrl.InsertItem(GetResString(IDS_RUP_UPLOADS), strBuffer, &uploadlistctrl, 1, TRUE);
		
	rollupctrl.InsertItem(GetResString(IDS_RUP_INFO), "", &infolistctrl, 2, FALSE);
//	rollupctrl.SetHeaderColor(2, 0, GetSysColor(COLOR_3DSHADOW));

	AddAnchor(rollupctrl.m_hWnd, TOP_LEFT, BOTTOM_RIGHT);
	InitRollupItemHeights();

	// create tooltip
	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 20000);
	m_ttip.SetDelayTime(TTDT_INITIAL, theApp.glob_prefs->GetToolTipDelay()*1000);
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!
	m_ttip.AddTool(&downloadlistctrl);
	m_ttip.AddTool(&uploadlistctrl);
	m_iOldToolTipItemDown = -1;
	m_iOldToolTipItemUp = -1;
	m_iOldToolTipItemQueue = -1;
	
	downloadlistctrl.SetOwner(this);
	uploadlistctrl.SetOwner(this);
	queuelistctrl.SetOwner(this);

	EMULE_CATCH

	return true;
}

void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
}

// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	// handle tooltip updating, when mouse is moved from one item to another
	if (pMsg->message == WM_MOUSEMOVE)
		UpdateToolTips();

	// relay mouse events to tooltip control
	if (pMsg->message == WM_LBUTTONDOWN || pMsg->message== WM_LBUTTONUP || pMsg->message== WM_MOUSEMOVE)
		m_ttip.RelayEvent(pMsg);

	if(pMsg->message == USRMSG_SWITCHUPLOADLIST)
		SwitchUploadList();

	return CResizableDialog::PreTranslateMessage(pMsg);
}

void CTransferWnd::UpdateToolTips(void)
{	
	EMULE_TRY

	int sel = GetItemUnderMouse((CListCtrl*)rollupctrl.GetItemClient(0));	// this is a quick fix,
	if (sel != -1)															// we should find a better solution
	{
		if (sel != m_iOldToolTipItemDown)
		{
			if(m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemDown = sel;
			return;
		}
	}
	int sel2 = GetItemUnderMouse((CListCtrl*)rollupctrl.GetItemClient(1));	// see above
	if (sel2 != -1)
	{
		if (sel2 != m_iOldToolTipItemUp)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemUp = sel2;
			return;
		}
	}
/* no tooltips needed ATM
	int sel3 = GetItemUnderMouse(&queuelistctrl);
	if (sel3 != -1)
	{
		if (sel3 != m_iOldToolTipItemQueue)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemQueue = sel3;
		}
	}
*/
	if (sel == -1 && sel2 == -1 /*&& sel3 != -1*/)
		m_ttip.Pop();

	EMULE_CATCH
}

int CTransferWnd::GetItemUnderMouse(CListCtrl* ctrl)
{
	EMULE_TRY

	CPoint pt;
	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);
	LVHITTESTINFO hit, subhit;
	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);
	int sel = ctrl->HitTest(&hit);
	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
	{
		if (subhit.iSubItem == 0)
			return sel;
	}

	EMULE_CATCH

	return LB_ERR;
}

BOOL CTransferWnd::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult)
{
	EMULE_TRY

	TOOLTIPTEXT *pText = (TOOLTIPTEXT *)pNMH;
	int control_id = ::GetDlgCtrlID((HWND)pNMH->idFrom);
	if (!control_id)
		return FALSE;
	CString info;
	if (control_id == IDC_DOWNLOADLIST)
	{
		if (downloadlistctrl.GetItemCount() < 1)
			return FALSE;
		int sel = GetItemUnderMouse(&downloadlistctrl);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		CMuleCtrlItem* content = (CMuleCtrlItem*)downloadlistctrl.GetItemData(sel);
		if (content->IsFile()) // for downloading files
		{
			CPartFile* partfile = content->GetFile();
			info = GetDownloadFileInfo(partfile);	// kuchin
		}
		else if (content->IsSource()) // for sources
		{
			bool bA4AF = content->IsAskedForAnotherFile();
			CUpDownClient* client = content->GetSource();
			in_addr server;
			server.S_un.S_addr = client->GetServerIP();

			info.Format(GetResString(IDS_NICKNAME)+" %s ("+GetResString(IDS_USERID)+": %u)\n"
				+GetResString(IDS_CLIENT)+" %s:%d\n"
				+GetResString(IDS_SERVER)+" %s:%d\n"
				+GetResString(IDS_SOURCEINFO),
						client->GetUserName(), client->GetUserID(),
						client->GetFullIP(), client->GetUserPort(), 
						inet_ntoa(server), client->GetServerPort(),
						/*client->GetAskedCount()*/0, client->GetAvailablePartCount());
			if (!bA4AF)
			{	// normal client
				info += GetResString(IDS_CLIENTSOURCENAME) + CString(client->GetClientFilename());
			}
			else
			{
				//Cax2- get local file name
				try{
					info += GetResString(IDS_ASKEDFAF) + ": " + client->reqfile->GetFileName();
				}catch(...){}
            }
         //-For File Comment-// 
		     try { 
				if (!bA4AF){
					if (client->GetFileComment() != "") { 
						info += "\n" + GetResString(IDS_CMT_READ)  + " " + CString(client->GetFileComment()); 
					} 
					else { 
						//No comment entered 
						info += "\n" + GetResString(IDS_CMT_NONE); 
					} 
					info += "\n" + GetRateString(client->GetFileRate());
				}
			} catch(...) { 
				//Information not received = not connected or connecting 
				info += "\n" + GetResString(IDS_CMT_NOTCONNECTED); 
			} 
	         //-End file comment-//
		}
	}
	else if (control_id == IDC_UPLOADLIST)
	{
		if (uploadlistctrl.GetItemCount() < 1)
			return FALSE;
		int sel = GetItemUnderMouse(&uploadlistctrl);
		if (sel < 0 || sel == 65535)
			return FALSE;

		CUpDownClient* client = (CUpDownClient*)uploadlistctrl.GetItemData(sel);
		info = GetUploadFileInfo(client);
	}
///*	no tooltips needed ATM
	else if (control_id == IDC_QUEUELIST)
	{
		if (queuelistctrl.GetItemCount() < 1)
			return FALSE;
		int sel = GetItemUnderMouse(&queuelistctrl);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		CUpDownClient* client = (CUpDownClient*)uploadlistctrl.GetItemData(sel);
		in_addr server;
		server.S_un.S_addr = client->GetServerIP();

		info.Format("Nickname: %s (UserID: %u)\n"
					"Client %s:%d\n"
					"Server %s:%d\n"
					"AskedCount: %d - AvailablePartCount: %d",
					client->GetUserName(), client->GetUserID(),
					client->GetFullIP(), client->GetUserPort(), 
					inet_ntoa(server), client->GetServerPort(),
					client->GetAskedCount(), client->GetAvailablePartCount());

	}
//*/
	m_strToolTip.ReleaseBuffer(); // release old used buffer
	m_strToolTip = info;
	pText->lpszText = m_strToolTip.GetBuffer(1);
	pText->hinst = NULL; // we are not using a resource
	PostMessage(WM_ACTIVATE);

	EMULE_CATCH

	return TRUE;
}

void CTransferWnd::SwitchUploadList()
{
	EMULE_TRY

	switch(m_nActiveWnd)
	{
		case 0:
		{	
			m_nActiveWnd = 1;
			rollupctrl.SetText(1, GetResString(IDS_RUP_ONQUEUE), true);
			uploadlistctrl.ShowWindow(SW_HIDE);
			rollupctrl.SetItemClient(1, &queuelistctrl);
			rollupctrl.Invalidate();
			break;
		}
		case 1:
		{	
			m_nActiveWnd = 0;
			rollupctrl.SetText(1, GetResString(IDS_RUP_UPLOADS), true);
			queuelistctrl.ShowWindow(SW_HIDE);
			rollupctrl.SetItemClient(1, &uploadlistctrl);
			rollupctrl.Invalidate();
			break;
		}
		default: break;
	}

	EMULE_CATCH
}

void CTransferWnd::Localize()
{
	EMULE_TRY

	downloadlistctrl.Localize();
	uploadlistctrl.Localize();
	queuelistctrl.Localize();
	infolistctrl.Localize();
	//Cax2 - localize the rollup control
	rollupctrl.SetText(0,GetResString(IDS_RUP_DOWNLOADS), true);
	rollupctrl.SetText(1,GetResString((m_nActiveWnd==0)?IDS_RUP_UPLOADS:IDS_RUP_ONQUEUE), true);
	rollupctrl.SetText(2,GetResString(IDS_RUP_INFO), true);
	if(m_bFirstShow)
	{
		m_bFirstShow = false;
		infolistctrl.SetColumn(theApp.glob_prefs->GetDetailColumnWidth());
	}

	EMULE_CATCH
}

void CTransferWnd::UpdateDownloadHeader()
{
	EMULE_TRY

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_DOWNINFO), theApp.downloadqueue->GetFileCount(),
						theApp.downloadqueue->GetTransferingFiles(),
							(float)theApp.downloadqueue->GetDatarate()/1024);
	rollupctrl.SetText(0, strBuffer);

	EMULE_CATCH
}
void CTransferWnd::UpdateUploadHeader()
{
	EMULE_TRY

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_UPINFO), theApp.uploadqueue->GetWaitingUserCount(),
						theApp.uploadqueue->GetUploadQueueLength(), 
							theApp.uploadqueue->GetBanCount(),
								(float)theApp.uploadqueue->GetDatarate()/1024);
	rollupctrl.SetText(1, strBuffer);

	EMULE_CATCH
}
void CTransferWnd::UpdateInfoHeader()
{		
	EMULE_TRY

	CString strInfoHeader = "";

	switch(infolistctrl.GetType())
	{	
		case 1: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOUSER), infolistctrl.GetName()); 
			break;
		case 2: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOFILE), infolistctrl.GetName()); 
			break;
		default : 
			strInfoHeader = "";
			break;
	}
	
	rollupctrl.SetText(2, strInfoHeader);

	EMULE_CATCH
}

void CTransferWnd::InitRollupItemHeights()
{
	EMULE_TRY

	float fItemHeights[3][8];
		
	FILE *f;
	char* fullpath = new char[strlen(theApp.glob_prefs->GetAppDir())+MAX_PATH]; // i_a
	sprintf(fullpath,"%sgui.dat", theApp.glob_prefs->GetAppDir());
	f = fopen(fullpath, "rb");
	delete [] fullpath;
	
	bool bUseDefault = false;

	if(f)
	{
		char cTemp[512];
		char *pToken;
        char seps[] = "|\n";

		for(int exp = 0; exp < 8; exp++)
		{
			if(!fgets(cTemp, 512, f))
			{
				bUseDefault = true;
				break;
			}

			float fTotalHeight = 0;
			pToken = strtok(cTemp, seps);
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					exp = 8;
					break;
				}

				fItemHeights[i][exp] = atof(pToken);
//				TRACE("fItemHeights[%d][%d] = %f\r\n", i, exp, atof(pToken));
				pToken = strtok(NULL, seps);

				if(fItemHeights[i][exp] < 0)	// this should never happen
				{
					bUseDefault = true;
					exp = 8;
					i = 3;
				}
				fTotalHeight += fItemHeights[i][exp];
			}
			
			// this should also never happen
			if(fTotalHeight >= 101 || fTotalHeight <= 99 && fTotalHeight != 0) // i'm very tolerant ;)
			{
				bUseDefault = true;
				exp = 8;
			}
		}	

		if(!fgets(cTemp, 512, f))
			bUseDefault = true;
//		TRACE("lastline = %s", cTemp);
		if(!bUseDefault)
		{
			pToken = strtok(cTemp, seps);
			
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					i = 3;
				}

				rollupctrl.ExpandItem(i, atoi(pToken));
				pToken = strtok(NULL, seps);
			}
		}
		
		fclose(f);
	}
	else
		bUseDefault = true;
	
	if(bUseDefault)
	{
	BYTE bExpandedItems; 

	bExpandedItems = 0x00;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x01;
	fItemHeights[0][bExpandedItems] = 100;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x02;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 100;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x03;
	fItemHeights[0][bExpandedItems] = 70;
	fItemHeights[1][bExpandedItems] = 30;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x04;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 100;

	bExpandedItems = 0x05;
	fItemHeights[0][bExpandedItems] = 70;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 30;

	bExpandedItems = 0x06;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 70;
	fItemHeights[2][bExpandedItems] = 30;

	bExpandedItems = 0x07;
	fItemHeights[0][bExpandedItems] = 50;
	fItemHeights[1][bExpandedItems] = 25;
	fItemHeights[2][bExpandedItems] = 25;
	}

	rollupctrl.SetItemHeights(0, fItemHeights[0], 8);
	rollupctrl.SetItemHeights(1, fItemHeights[1], 8);
	rollupctrl.SetItemHeights(2, fItemHeights[2], 8);

	EMULE_CATCH
}

void CTransferWnd::SafeRollupItemHeights()
{
	EMULE_TRY

	FILE *f;
	char* fullpath = new char[strlen(theApp.glob_prefs->GetAppDir())+MAX_PATH]; // i_a
	sprintf(fullpath,"%sgui.dat", theApp.glob_prefs->GetAppDir());
	f = fopen(fullpath, "wb");
	delete [] fullpath;

	if(f)
	{
		for(int exp = 0; exp < 8; exp++)
		{	
			float f1,f2,f3;
			f1 = rollupctrl.GetItem(0)->pSizes[exp];
			f2 = rollupctrl.GetItem(1)->pSizes[exp];
			f3 = rollupctrl.GetItem(2)->pSizes[exp];
	
			// get rid off some rounding errors: ///
			if(f3)
				f3 = f1 ? (f2 ? (100 - f1 - f2) : (100 - f1)) : (100 - f2);
			else if(f2)
				f2 = 100 - f1;				
			////////////////////////////////////////

			fprintf(f, "%f|%f|%f\n", f1, f2, f3);
		}
		fprintf(f, "%d|%d|%d\n", rollupctrl.GetItem(0)->pHeader->IsExpanded(),
					rollupctrl.GetItem(1)->pHeader->IsExpanded(), rollupctrl.GetItem(2)->pHeader->IsExpanded());
		fclose(f);
	}

	EMULE_CATCH
}

BOOL CTransferWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
		case USRMSG_SWITCHUPLOADLIST:
			SwitchUploadList();
			break;
		default: 
			break;
	}
	
	return CResizableDialog::OnCommand(wParam, lParam);
}

// kuchin
CString CTransferWnd::GetDownloadFileInfo(CPartFile *partfile)
{
	EMULE_TRY

	if(partfile == NULL)
		return "";
	CString sRet;
	CString strHash;
	strHash.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",
	partfile->GetFileHash()[0],partfile->GetFileHash()[1],partfile->GetFileHash()[2],partfile->GetFileHash()[3],partfile->GetFileHash()[4],partfile->GetFileHash()[5],partfile->GetFileHash()[6],partfile->GetFileHash()[7],
	partfile->GetFileHash()[8],partfile->GetFileHash()[9],partfile->GetFileHash()[10],partfile->GetFileHash()[11],partfile->GetFileHash()[12],partfile->GetFileHash()[13],partfile->GetFileHash()[14],partfile->GetFileHash()[15]);

	CTime t(partfile->GetFileDate());

	char lsc[50]; char compl[50]; char lastprogr[50];

	
	sprintf(compl,"%s/%s",CastItoXBytes(partfile->GetCompletedSize()),CastItoXBytes(partfile->GetFileSize()));

	if (partfile->lastseencomplete==NULL) sprintf(lsc,GetResString(IDS_UNKNOWN).MakeLower() ); else
		sprintf(lsc,partfile->localelastseencomplete());
	//sprintf(lsc,partfile->lastseencomplete.Format( "%A, %x, %X"));

	if (partfile->GetCompletedSize()==0) sprintf(lastprogr,GetResString(IDS_UNKNOWN).MakeLower() ); else
		sprintf(lastprogr,partfile->localelastdowntransfer());
		
		//sprintf(lastprogr,partfile->GetLastDownTransfer().Format("%A, %x, %X"));

	float availability = 0;
	if(partfile->GetPartCount() != 0) {
		availability = partfile->GetAvailablePartCount() * 100 / partfile->GetPartCount();
	}
	sRet.Format(GetResString(IDS_DL_FILENAME)+": %s (%d %s)\n"
		+GetResString(IDS_DATE)+": %s - "+ GetResString(IDS_FD_HASH) +" %s\n"
		+GetResString(IDS_PARTINFOS)+
		GetResString(IDS_PARTINFOS2)+"\n%s\n%s",
				partfile->GetFileName(), partfile->GetFileSize(),GetResString(IDS_BYTES),
				t.Format("%A, %B %d, %Y"), strHash,
				partfile->GetPartMetFileName(), partfile->GetPartCount(),GetResString(IDS_AVAIL),partfile->GetAvailablePartCount(),availability,
				(int)partfile->GetPercentCompleted(), compl, partfile->GetTransferingSrcCount(),
				GetResString(IDS_LASTSEENCOMPL)+" "+CString(lsc),
                GetResString(IDS_LAST_FILE_PROGRESS) +" "+CString(lastprogr));

	return sRet;

	EMULE_CATCH

	return "";

}

// kuchin
CString CTransferWnd::GetUploadFileInfo(CUpDownClient *client)
{
	EMULE_TRY

	if(client == NULL)
		return "";
	CString sRet;
	CKnownFile* file = theApp.sharedfiles->GetFileByID(client->reqfileid);
	// build info text and display it
	sRet.Format(GetResString(IDS_USERINFO), client->GetUserName(), client->GetUserID());
	if (file)
	{
		sRet += GetResString(IDS_SF_REQUESTED) + CString(file->GetFileName()) + "\n";
		CString stat;
		stat.Format(GetResString(IDS_FILESTATS_SESSION)+GetResString(IDS_FILESTATS_TOTAL),
					file->statistic.GetAccepts(), file->statistic.GetRequests(), file->statistic.GetTransfered(),
					file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), file->statistic.GetAllTimeTransfered());
		sRet += stat;
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;

	EMULE_CATCH
	
	return "";
}